#include <oxstd.h>
#import <packages/dpd/dpd>
#import <lib/longrun>
#include "dpdrecur.ox"

main()
{
    decl dpd = new DPDEx(), time = timer();

    dpd.LoadIn7("2739n.in7");			       // load data

    dpd.SetTest(TRUE, 2); // specification and AR 1-2 tests
	dpd.SetPrint(FALSE);	  // switch off standard output

	// formulate restrictions
	decl amr = {<1,0,0,0,0;0,1,0,0,0;0,0,0,1,0>     ,<1,0,0,1,0>     ,<1,0,0,0,0>,<0,0,0,1,0>,<1,0,0,0,0;0,0,0,1,0>,<0,1,0,0,0>,<0,0,1,0,0>  ,<1,0,0,0,0;0,0,0,1,0;0,1,0,0,0>,<1,0,0,0,0;0,0,0,1,0;0,1,0,0,0;0,0,1,0,0> };
	decl avr = {    <0;0;0>         ,    <1>         ,    <1>    ,    <0>    ,       <1;0>         ,    <1>    ,   <-0.1>    ,           <1;0;1>             ,               <1;0;1;-0.1>               };
	decl asr = { "beta*=gamma*=zeta*=0" , "beta*+zeta*=1" , "beta*=1" , "zeta*=0" , "beta*=1&zeta*=0"   , "gamma*=1","delta*=-0.1", "beta*=1&zeta*=0&gamma*=1"    , "beta*=1&zeta*=0&gamma*=1&delta*=-0.1"   };
	
	//---------------GMM, differenced transformations	
	print("\n\n***** GMM, differenced Transformations, exogenous regressors (col 1)\n");
    dpd.SetYear("DATES");     // specify columns with years
    dpd.SetGroup("SECTORS");		     // and with groups
	
	dpd.Select(Y_VAR, {"w", 0, 1});      // formulate model
    dpd.Select(X_VAR, {"p", 0, 1, "q", 0, 1, "u", 0, 1, "pc", 0, 1});
	dpd.Select(I_VAR, {"p", 0, 1, "q", 0, 1, "u", 0, 1, "pc", 0, 1});

	dpd.Gmm("w", 2, 3);
//	dpd.SetDummies(D_CONSTANT + D_TIME);		     // specify dummies

	DpdRecur(dpd, "DATES", 5, M_2STEP, T_DIFFERENCES, 1, 1, "BDK2008_LRDIFF.in7", amr, avr, asr);	

	//---------------GMM, differenced transformations, endogenous regressors
	print("\n\n***** GMM, differenced Transformations, endogenous regressors (col 2)\n");
	dpd.DeSelect();
	dpd.SetYear("DATES");
	dpd.Select(Y_VAR, {"w", 0, 1});      // formulate model
    dpd.Select(X_VAR, {"p", 0, 1, "q", 0, 1, "u", 0, 1, "pc", 0, 1});
	dpd.Select(I_VAR, {"pc", 0, 1});

	dpd.Gmm("w", 2, 3);
	dpd.Gmm("p", 2, 3);
	dpd.Gmm("q", 2, 3);
	dpd.Gmm("u", 2, 3);

	DpdRecur(dpd, "DATES", 5, M_2STEP, T_DIFFERENCES, 1, 1, "BDK2008_LRDIFFEND.in7", amr, avr, asr);

	//---------------GMM, system estimation, exogenous regressors	
	print("\n\n***** GMM, system estimation, exogenous regressors (col 3)\n");
	dpd.DeSelect();
   	dpd.SetYear("DATES");     // specify columns with years
    dpd.SetGroup("SECTORS");
//	dpd.SetDummies(D_CONSTANT + D_TIME);		     // specify dummies
	dpd.Select(Y_VAR, {"w", 0, 1});      // formulate model
    dpd.Select(X_VAR, {"p", 0, 1, "q", 0, 1, "u", 0, 1, "pc", 0, 1});
	dpd.Select(I_VAR, {"p", 0, 1, "q", 0, 1, "u", 0, 1, "pc", 0, 1});

	dpd.Gmm("w", 2, 3);
    dpd.GmmLevel("w", 1, 1);  // GMM instruments for levels 

	DpdRecur(dpd, "DATES", 5, M_2STEP, T_DIFFERENCES, 1, 1, "BDK2008_LRSYS.in7", amr, avr, asr);

	//---------------GMM, system estimation, endogenous regressors	
	print("\n\n***** GMM, system estimation, endogenous regressors (col 4)\n");
  	dpd.DeSelect();
	dpd.SetYear("DATES");
	dpd.Select(Y_VAR, {"w", 0, 1});      // formulate model
    dpd.Select(X_VAR, {"p", 0, 1, "q", 0, 1, "u", 0, 1, "pc", 0, 1});
	dpd.Select(I_VAR, {"pc", 0, 1});

	dpd.Gmm("w", 2, 3);
	dpd.Gmm("p", 2, 3);
	dpd.Gmm("q", 2, 3);
	dpd.Gmm("u", 2, 3);

	dpd.GmmLevel("w", 1, 1);
	dpd.GmmLevel("p", 1, 1);
    dpd.GmmLevel("q", 1, 1);
	dpd.GmmLevel("u", 1, 1);
//	dpd.SetOptions(TRUE,TRUE,-1,-1);

//	dpd.SetGroup("SECTORS");
	dpd.SetDummies(D_CONSTANT);		     // specify dummies
	dpd.SetMethod(M_2STEP);
//	dpd.Estimate();
	DpdRecur(dpd, "DATES", 5, M_2STEP, T_DIFFERENCES, 1, 1, "BDK2008_LRSYSEND.in7", amr, avr, asr);

	delete dpd;                     // finished with object
    print("\ntime: ", timespan(time), "\n");
}
   